package org.jboss.remoting.util;

import java.util.Timer;
import java.util.TimerTask;


/**
 * @author <a href="mailto:tom.elrod@jboss.com">Tom Elrod</a>
 */
public class TimerUtil
{
   private static Timer timer = null;
   
   private static synchronized void init()
   {
      TimerUtil.timer = new Timer(true);
   }

   public static synchronized void schedule(TimerTask task, long period)
   {
      if (TimerUtil.timer == null)
      {
         TimerUtil.init();
      }

      //schedule at fixed delay (not rate)
      TimerUtil.timer.schedule(task, period, period);
   }

   public static synchronized void destroy()
   {
      if (TimerUtil.timer != null)
      {
         TimerUtil.timer.cancel();
         TimerUtil.timer = null;
      }
   }
}
