package org.jboss.test.remoting.callback.push.bidirectional.multiplex;

import junit.framework.TestCase;
import org.jboss.remoting.Client;
import org.jboss.remoting.InvokerLocator;
import org.jboss.remoting.callback.Callback;
import org.jboss.remoting.callback.HandleCallbackException;
import org.jboss.remoting.callback.InvokerCallbackHandler;

import java.util.HashMap;

/**
 * @author <a href="mailto:tom.elrod@jboss.com">Tom Elrod</a>
 */
public class MultiplexCallbackTestClient extends TestCase
{
   private String locatorUri = "multiplex://localhost:8999";
   private boolean gotCallback = false;

   public void testCallback() throws Throwable
   {
      Client client = new Client(new InvokerLocator(locatorUri));
      client.connect();
      InvokerCallbackHandler testCallbackHandler = new MultiplexCallbackTestClient.TestCallbackHandler();
      client.addListener(testCallbackHandler, new HashMap(), "foobar");
      client.invoke("foobar");

      Thread.sleep(5000);

      client.removeListener(testCallbackHandler);
      client.disconnect();

      assertTrue(gotCallback);
   }

   public class TestCallbackHandler implements InvokerCallbackHandler
   {

      public void handleCallback(Callback callback) throws HandleCallbackException
      {
         System.out.println("callback = " + callback);
         Object handle = callback.getCallbackHandleObject();
         if ("foobar".equals(handle))
         {
            gotCallback = true;
         }
      }
   }
}
