/***************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ***************************************/
package org.jboss.test.remoting.performance.spring.http.web;

import org.jboss.remoting.callback.Callback;
import org.jboss.remoting.callback.HandleCallbackException;
import org.jboss.remoting.callback.InvokerCallbackHandler;
import org.jboss.test.remoting.performance.spring.http.client.SpringHttpCallbackServer;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

/**
 * @author <a href="mailto:tom@jboss.org">Tom Elrod</a>
 */
public class SpringHttpHandler implements InvokerCallbackHandler
{
   private SpringHttpCallbackServer springHttpCallbackServer;

   public void start()
   {
      Resource res = new ClassPathResource("SpringHttpCallbackServerService.xml", SpringHttpHandler.class);
      BeanFactory factory = new XmlBeanFactory(res);
      springHttpCallbackServer = (SpringHttpCallbackServer)factory.getBean("springHttpCallbackServerService");

   }

   public SpringHttpCallbackServer getSpringHttpCallbackServer()
   {
      return springHttpCallbackServer;
   }

   public void setSpringHttpCallbackServer(SpringHttpCallbackServer springHttpCallbackServer)
   {
      this.springHttpCallbackServer = springHttpCallbackServer;
   }

   public void handleCallback(Callback callback) throws HandleCallbackException
   {
      System.out.println("Need to make call on SpringRMICallbackServer with results. " + callback);

      try
      {
         springHttpCallbackServer.finishedProcessing(callback);
      }
      catch(Exception e)
      {
         e.printStackTrace();
         throw new HandleCallbackException(e.getMessage());
      }
   }
}
