/***************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ***************************************/
package org.jboss.test.remoting.performance.spring.rmi;

import org.jboss.remoting.callback.Callback;
import org.jboss.remoting.callback.HandleCallbackException;
import org.jboss.remoting.callback.InvokerCallbackHandler;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

/**
 * @author <a href="mailto:tom@jboss.org">Tom Elrod</a>
 */
public class SpringRMIHandler implements InvokerCallbackHandler
{
   private SpringRMICallbackServer springRMICallbackServer;

   public void start()
   {
      Resource res = new ClassPathResource("SpringRMICallbackServerService.xml", SpringRMIHandler.class);
      BeanFactory factory = new XmlBeanFactory(res);
      springRMICallbackServer = (SpringRMICallbackServer)factory.getBean("springRMICallbackServerService");

   }

   public SpringRMICallbackServer getSpringRMICallbackServer()
   {
      return springRMICallbackServer;
   }

   public void setSpringRMICallbackServer(SpringRMICallbackServer springRMICallbackServer)
   {
      this.springRMICallbackServer = springRMICallbackServer;
   }

   public void handleCallback(Callback callback) throws HandleCallbackException
   {
      System.out.println("Need to make call on SpringRMICallbackServer with results. " + callback);

      try
      {
         springRMICallbackServer.finishedProcessing(callback);
      }
      catch(Exception e)
      {
         e.printStackTrace();
         throw new HandleCallbackException(e.getMessage());
      }
   }
}