package org.jboss.test.remoting.transport.socket.ssl.serversocketrefresh;

import junit.framework.TestCase;
import org.jboss.remoting.Client;
import org.jboss.remoting.InvokerLocator;
import org.jboss.remoting.security.SSLSocketBuilder;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Michael Voss
 *
 */
public class TestClient extends TestCase{
	
	private String keyStorePath="src/tests/org/jboss/test/remoting/transport/socket/ssl/serversocketrefresh/certificate/clientKeyStore";
	private String trustStorePath="src/tests/org/jboss/test/remoting/transport/socket/ssl/serversocketrefresh/certificate/clientTrustStore";
	private String keyStorePassword="testpw";
	private String trustStorePassword="testpw";
	InvokerLocator locator;
	Client client;
	Map configuration;
	
	public void setUp() throws Exception{
		locator=new InvokerLocator("sslsocket://localHost:2001");
		
		//the client side connection endpoint
		configuration = new HashMap();

      //String keyStorePath = this.getClass().getResource("certificate/serverKeyStore").getFile();
      //String trustStorePath = this.getClass().getResource("certificate/serverTrustStore").getFile();
		String keyStorePath = this.getClass().getResource("certificate/clientKeyStore").getFile();
	    String trustStorePath = this.getClass().getResource("certificate/clientTrustStore").getFile();

        configuration.put(SSLSocketBuilder.REMOTING_KEY_STORE_TYPE, "JKS");
		configuration.put(SSLSocketBuilder.REMOTING_KEY_STORE_FILE_PATH, keyStorePath);
		configuration.put(SSLSocketBuilder.REMOTING_KEY_STORE_PASSWORD, keyStorePassword);
		configuration.put(SSLSocketBuilder.REMOTING_KEY_STORE_ALGORITHM, "SunX509");
		
		configuration.put(SSLSocketBuilder.REMOTING_TRUST_STORE_TYPE, "JKS");
		configuration.put(SSLSocketBuilder.REMOTING_TRUST_STORE_FILE_PATH, trustStorePath);
		configuration.put(SSLSocketBuilder.REMOTING_TRUST_STORE_PASSWORD, trustStorePassword);
		configuration.put(SSLSocketBuilder.REMOTING_TRUST_STORE_ALGORITHM, "SunX509");
		
		client=new Client(locator,"Sample",configuration);				
		
		client.connect();		
		
	}
	
	public void tearDown() throws Exception{
		Thread.sleep(10000);//let the server fetch his new truststore and refresh serversocket
		client.disconnect();
		Thread.sleep(5000);
		setUp();//secondPass -> client is not accepted by new truststore
		try {
			test();//secondPass -> client is not accepted by new truststore
		} catch (Throwable e) {
			client.disconnect();
			return;
		}
		client.disconnect();
		throw new Exception("should not reach this point");//because client should not be accepted by new server truststore
		
	}
	
	/**
	 * @throws Throwable
	 */
	public void test() throws Throwable{
		System.err.println("Invoking server with 'something'");
		System.err.println("Server answer is: "+client.invoke("something"));
	}
	
	
	
}
